diff -uNrd ircd-hybrid-7.0/include/s_serv.h anynet-3.0/include/s_serv.h
--- ircd-hybrid-7.0/include/s_serv.h	Mon Jun  9 22:16:52 2003
+++ anynet-3.0/include/s_serv.h	Mon Feb  2 05:11:15 2004
@@ -110,6 +110,10 @@
 #define CIPHER_RC5_8    6
 #define CIPHER_RC5_12   7
 #define CIPHER_RC5_16   8
+/* rain - add AES */
+#define CIPHER_AES_128  9
+#define CIPHER_AES_192  10
+#define CIPHER_AES_256  11
 
 /* Cipher Capabilities */
 #define CAP_ENC_BF_128          0x00000001
@@ -121,6 +125,12 @@
 #define CAP_ENC_RC5_8_128       0x00000040
 #define CAP_ENC_RC5_12_128      0x00000080
 #define CAP_ENC_RC5_16_128      0x00000100
+/* rain - add BF/192, BF/256, AES/128, AES/192, and AES/256 */
+#define CAP_ENC_BF_192          0x00000200
+#define CAP_ENC_BF_256          0x00000400
+#define CAP_ENC_AES_128         0x00000800
+#define CAP_ENC_AES_192         0x00001000
+#define CAP_ENC_AES_256         0x00002000
 
 #define CAP_ENC_ALL             0xFFFFFFFF
 
@@ -168,19 +178,40 @@
 #else
 #define USE_CIPHER_RC5      0
 #endif
-
+/* rain - AES */
+#ifdef HAVE_EVP_AES_128_CFB
+#define USE_CIPHER_AES_128  1
+#else
+#define USE_CIPHER_AES_128  0
+#endif
+#ifdef HAVE_EVP_AES_192_CFB
+#define USE_CIPHER_AES_192  1
+#else
+#define USE_CIPHER_AES_192  0
+#endif
+#ifdef HAVE_EVP_AES_256_CFB
+#define USE_CIPHER_AES_256  1
+#else
+#define USE_CIPHER_AES_256  0
+#endif
 
 /* Only enable ciphers supported by available version of OpenSSL */
+/* rain - add AES and BF192/256 */
 #define CAP_ENC_MASK    \
-             (((USE_CIPHER_BF   * CAP_ENC_ALL) & CAP_ENC_BF_128)         | \
-              ((USE_CIPHER_BF_V * CAP_ENC_ALL) & CAP_ENC_BF_168)         | \
-              ((USE_CIPHER_CAST * CAP_ENC_ALL) & CAP_ENC_CAST_128)       | \
-              ((USE_CIPHER_DES  * CAP_ENC_ALL) & CAP_ENC_DES_56)         | \
-              ((USE_CIPHER_3DES * CAP_ENC_ALL) & CAP_ENC_3DES_168)       | \
-              ((USE_CIPHER_IDEA * CAP_ENC_ALL) & CAP_ENC_IDEA_128)       | \
-              ((USE_CIPHER_RC5  * CAP_ENC_ALL) & CAP_ENC_RC5_8_128)      | \
-              ((USE_CIPHER_RC5  * CAP_ENC_ALL) & CAP_ENC_RC5_12_128)     | \
-              ((USE_CIPHER_RC5  * CAP_ENC_ALL) & CAP_ENC_RC5_16_128))
+             (((USE_CIPHER_BF      * CAP_ENC_ALL) & CAP_ENC_BF_128)       | \
+              ((USE_CIPHER_BF_V    * CAP_ENC_ALL) & CAP_ENC_BF_168)       | \
+              ((USE_CIPHER_BF_V    * CAP_ENC_ALL) & CAP_ENC_BF_192)       | \
+              ((USE_CIPHER_BF_V    * CAP_ENC_ALL) & CAP_ENC_BF_256)       | \
+              ((USE_CIPHER_CAST    * CAP_ENC_ALL) & CAP_ENC_CAST_128)     | \
+              ((USE_CIPHER_DES     * CAP_ENC_ALL) & CAP_ENC_DES_56)       | \
+              ((USE_CIPHER_3DES    * CAP_ENC_ALL) & CAP_ENC_3DES_168)     | \
+              ((USE_CIPHER_IDEA    * CAP_ENC_ALL) & CAP_ENC_IDEA_128)     | \
+              ((USE_CIPHER_RC5     * CAP_ENC_ALL) & CAP_ENC_RC5_8_128)    | \
+              ((USE_CIPHER_RC5     * CAP_ENC_ALL) & CAP_ENC_RC5_12_128)   | \
+              ((USE_CIPHER_RC5     * CAP_ENC_ALL) & CAP_ENC_RC5_16_128)   | \
+              ((USE_CIPHER_AES_128 * CAP_ENC_ALL) & CAP_ENC_AES_128)      | \
+              ((USE_CIPHER_AES_192 * CAP_ENC_ALL) & CAP_ENC_AES_192)      | \
+              ((USE_CIPHER_AES_256 * CAP_ENC_ALL) & CAP_ENC_AES_256))
 
 #define IsCapableEnc(x, cap)    ((x)->localClient->enc_caps &   (cap))
 #define SetCapableEnc(x, cap)   ((x)->localClient->enc_caps |=  (cap))
diff -uNrd ircd-hybrid-7.0/include/send.h anynet-3.0/include/send.h
--- ircd-hybrid-7.0/include/send.h	Fri Feb 14 18:01:49 2003
+++ anynet-3.0/include/send.h	Mon Feb  2 01:43:43 2004
@@ -44,7 +44,8 @@
 struct dlink_list;
 
 /* The nasty global also used in s_serv.c for server bursts */
-unsigned long current_serial;
+/* rain - extern this instead of defining it multiple times */
+extern unsigned long current_serial;
 
 /* send.c prototypes */
 
diff -uNrd ircd-hybrid-7.0/include/serno.h anynet-3.0/include/serno.h
--- ircd-hybrid-7.0/include/serno.h	Wed Jun 11 00:38:43 2003
+++ anynet-3.0/include/serno.h	Wed Feb  4 13:30:56 2004
@@ -1 +1,2 @@
-#define SERIALNUM "20030611_2"
+/* rain - updated */
+#define SERIALNUM "20040203_1"
diff -uNrd ircd-hybrid-7.0/include/setup.h.in anynet-3.0/include/setup.h.in
--- ircd-hybrid-7.0/include/setup.h.in	Sat Feb 15 11:32:44 2003
+++ anynet-3.0/include/setup.h.in	Mon Feb  2 01:45:00 2004
@@ -101,6 +101,16 @@
 /* Define if you have the EVP_bf_cfb function.  */
 #undef HAVE_EVP_BF_CFB
 
+/* rain - added AES cryptlink support */
+/* Define if you have the EVP_aes_128_cfb function. */
+#undef HAVE_EVP_AES_128_CFB
+
+/* Define if you have the EVP_aes_192_cfb function. */
+#undef HAVE_EVP_AES_192_CFB
+
+/* Define if you have the EVP_aes_256_cfb function. */
+#undef HAVE_EVP_AES_256_CFB
+
 /* Define if you have the EVP_cast5_cfb function.  */
 #undef HAVE_EVP_CAST5_CFB
 
@@ -202,3 +212,9 @@
 
 /* Define if you have the z library (-lz).  */
 #undef HAVE_LIBZ
+
+#ifdef HAVE_LIBCRYPTO
+/* rain - SSL client support */
+/* Define if you want SSL client support. */
+#undef SSL_CLIENT_SUPPORT
+#endif
diff -uNrd ircd-hybrid-7.0/include/ssl_client.h anynet-3.0/include/ssl_client.h
--- ircd-hybrid-7.0/include/ssl_client.h	Wed Dec 31 19:00:00 1969
+++ anynet-3.0/include/ssl_client.h	Fri Jan 23 02:18:50 2004
@@ -0,0 +1,42 @@
+#ifndef INCLUDED_ssl_h
+#define INCLUDED_ssl_h
+
+#include <openssl/ssl.h>
+#include <openssl/err.h>
+
+/* pre-declare this, we can't include client.h yet */
+struct Client;
+
+typedef enum {
+	SSLC_STATE_NONE,
+	SSLC_STATE_HANDSHAKE,
+	SSLC_STATE_CONNECTED,
+	SSLC_STATE_STARTTLS,
+	SSLC_STATE_DEAD
+} sslc_state;
+
+#define SSLC_HANDSHAKE_NOERROR		0
+#define SSLC_HANDSHAKE_INVALID_PARAM	-1
+#define SSLC_HANDSHAKE_NEW_FAIL		-2
+#define SSLC_HANDSHAKE_SETFD_FAIL	-3
+#define SSLC_HANDSHAKE_SSLERROR		-4
+#define SSLC_HANDSHAKE_ACCEPT_FAIL	-5
+
+#define SSLC_STAT_NONE			0x00
+#define SSLC_STAT_KEY_PUBLIC		0x01
+#define SSLC_STAT_KEY_PRIVATE		0x02
+#define SSLC_STAT_KEY_BOTH		(SSLC_STAT_KEY_PUBLIC | SSLC_STAT_KEY_PRIVATE)
+#define SSLC_STAT_STARTTLS		0x04
+#define SSLC_STAT_STARTTLS_OK		(SSLC_STAT_KEY_BOTH | SSLC_STAT_STARTTLS)
+
+extern void SSLC_CTX_init(void);
+extern void SSLC_CTX_deinit(void);
+extern int SSLC_handshake(struct Client *);
+extern int SSLC_write(struct Client *, const void *, int);
+extern int SSLC_read(struct Client *, void *, int);
+extern void SSLC_shutdown(struct Client *);
+extern void SSLC_CTX_deinit(void);
+extern const char *SSLC_cipherinfo(struct Client *, int);
+extern void SSLC_CertificateFile(const char *);
+extern void SSLC_PrivateKeyFile(const char *);
+#endif
diff -uNrd ircd-hybrid-7.0/include/stdinc.h anynet-3.0/include/stdinc.h
--- ircd-hybrid-7.0/include/stdinc.h	Fri May 24 19:39:13 2002
+++ anynet-3.0/include/stdinc.h	Mon Feb  2 01:45:43 2004
@@ -99,3 +99,8 @@
 #ifdef VMS
 #include <sys/ioctl.h>
 #endif
+
+/* rain - SSL client support */
+#ifdef SSL_CLIENT_SUPPORT
+#include "ssl_client.h"
+#endif
diff -uNrd ircd-hybrid-7.0/modules/core/m_kick.c anynet-3.0/modules/core/m_kick.c
--- ircd-hybrid-7.0/modules/core/m_kick.c	Sat Feb  1 15:12:24 2003
+++ anynet-3.0/modules/core/m_kick.c	Sun Sep 14 11:24:16 2003
@@ -127,7 +127,7 @@
     }
 #endif
 
-  if (!IsServer(source_p) && !is_any_op(chptr, source_p) ) 
+  if (!IsServer(source_p) && !is_any_op(chptr, source_p) && !IsService(source_p))
     { 
       /* was a user, not a server, and user isn't seen as a chanop here */
       
@@ -184,7 +184,7 @@
       return;
     }
 
-  if (IsMember(who, chptr))
+  if (IsMember(who, chptr) || IsService(who))
     {
       /* half ops cannot kick other halfops on private channels */
 #ifdef HALFOPS
diff -uNrd ircd-hybrid-7.0/modules/core/m_message.c anynet-3.0/modules/core/m_message.c
--- ircd-hybrid-7.0/modules/core/m_message.c	Sun Apr  6 12:47:37 2003
+++ anynet-3.0/modules/core/m_message.c	Wed Feb  4 16:36:09 2004
@@ -920,7 +920,8 @@
 		 me.name, source_p->name, command, nick, nick);
       return;
     }
-      
+
+#if 0 /* rain - we allow sending to the entire net */      
     if ((s = strrchr(nick, '.')) == NULL)
     {
       sendto_one(source_p, form_str(ERR_NOTOPLEVEL),
@@ -936,6 +937,7 @@
                  me.name, source_p->name, nick);
       return;
     }
+#endif
     
     sendto_match_butone(IsServer(client_p) ? client_p : NULL, source_p,
                         nick + 1,
diff -uNrd ircd-hybrid-7.0/modules/core/m_quit.c anynet-3.0/modules/core/m_quit.c
--- ircd-hybrid-7.0/modules/core/m_quit.c	Fri Feb 14 18:01:53 2003
+++ anynet-3.0/modules/core/m_quit.c	Thu Jan 22 03:30:46 2004
@@ -76,9 +76,9 @@
   if (ConfigFileEntry.client_exit && comment[0])
     {
 #ifndef VMS
-      snprintf(reason, TOPICLEN, "Quit: %s", comment);
+      snprintf(reason, TOPICLEN, "\"%s\"", comment);
 #else
-      sprintf(reason, "Quit: %s", comment);
+      sprintf(reason, "\"%s\"", comment);
 #endif
       comment = reason;
     }
diff -uNrd ircd-hybrid-7.0/modules/m_cryptlink.c anynet-3.0/modules/m_cryptlink.c
--- ircd-hybrid-7.0/modules/m_cryptlink.c	Sat May 31 03:30:31 2003
+++ anynet-3.0/modules/m_cryptlink.c	Mon Feb  2 01:47:36 2004
@@ -494,7 +494,7 @@
                                   char *key)
 {
   char *name;
-  unsigned char *tmp, *out;
+  char *tmp, *out; /* rain - made signed and casted to unsigned below */
   int len;
   int decoded_len;
 
@@ -503,7 +503,8 @@
   name = parv[2];
 
   /* parv[2] contains encrypted auth data */
-  if ( !(decoded_len = unbase64_block((char **)&tmp, parv[3],
+  /* rain - don't cast anymore */
+  if ( !(decoded_len = unbase64_block(&tmp, parv[3],
                                       strlen(parv[3]))) )
   {
     cryptlink_error(client_p, "SERV",
@@ -525,7 +526,8 @@
   }
   out = MyMalloc(RSA_size(ServerInfo.rsa_private_key));
 
-  len = RSA_private_decrypt(decoded_len, tmp, out,
+  /* rain - cast to unsigned now */
+  len = RSA_private_decrypt(decoded_len, (unsigned char *)tmp, out,
                             ServerInfo.rsa_private_key,
                             RSA_PKCS1_PADDING );
 
